/*
Author: Emanuele Lecchi
Company: Chaos Group
Year: 2018

Simple converter of V-Ray materials to Max Physical Material

note:This is unsupported by the author, or by Chaos group.
Feel free to modify and extend it as your needs demand.
*/
(
	--globals
	global physmatConverterRoll
	try (destroyDialog physmatConverterRoll) catch()
	
	--Locals
	theIS=theOS=undefined
	convertedCount=0
	
	fn implicitateMapInfluence inMap theInfluence =
	(
		if inMap != undefined then 
		(
			theOutput = output()
	-- 		show theOutput
			theOutput.map1=inMap
			theOutput.output.output_amount=theInfluence/100.0
			theOutput
		)
		else
		(
			undefined
		)
	)
	
	fn convertShader theIS theOS theGamma=
	(
		if (theIS!=undefined and theOS!=undefined) do
		(
			--shader defaults prepping
			theOS.name=theIS.name+"_converted"
			theOS.material_mode=1
			
			--diffuse
			theOS.base_weight=0
			if theIS.diffuse!=black or ( theIS.texmap_diffuse!=undefined and theIS.texmap_diffuse_on!=false ) do
			(			
				theOS.base_weight=1
				theOS.base_color=  ( point4 ((theIS.diffuse as point4).x ^(1/theGamma)) ((theIS.diffuse as point4).y ^(1/theGamma)) ((theIS.diffuse as point4).z ^(1/theGamma)) 1 ) as color
				theOS.Diff_Roughness=theIS.Diffuse_Roughness
				theOS.base_color_map=(implicitateMapInfluence theIS.texmap_diffuse theIS.texmap_diffuse_multiplier)
				theOS.base_color_map_on=theIS.texmap_diffuse_on
				theOS.diff_rough_map = (implicitateMapInfluence theIS.texmap_roughness theIS.texmap_roughness_multiplier) 
				theOS.diff_rough_map_on = theIS.texmap_roughness_on
			)
			--Reflection
			theOS.reflectivity=0
			if theIS.reflection!=black or (theIS.texmap_reflection!=undefined and theIS.texmap_reflection_on!=false) do
			(
				theOS.reflectivity=1
				theOS.metalness = 0
				theOS.refl_color = theIS.reflection
				theOS.refl_color_map = (implicitateMapInfluence theIS.texmap_reflection theIS.texmap_reflection_multiplier) 
				theOS.refl_color_map_on = theIS.texmap_reflection_on
				theOS.roughness_inv=true
				theOS.roughness=theIS.reflection_glossiness
				theOS.roughness_map =  (implicitateMapInfluence theIS.texmap_reflectionGlossiness theIS.texmap_reflectionGlossiness_multiplier) 
				theOS.roughness_map_on = theIS.texmap_reflectionGlossiness_on
				
				if not theIS.reflection_fresnel then
				(
					theOS.brdf_mode = off
					theOS.brdf_low = theOS.brdf_high = 1
				)
				else
				(
					theOS.brdf_mode = on
					if theIS.reflection_lockIOR then 
					(
						theOS.trans_ior = theIS.refraction_ior
						theOs.trans_ior_map = (implicitateMapInfluence theIS.texmap_refractionIor theIS.texmap_refractionIor_multiplier) 
						theOs.trans_ior_map_on = theIS.texmap_refractionIor_on
					)
					else
					(
						theOS.trans_ior = theIS.reflection_ior
						theOs.trans_ior_map = (implicitateMapInfluence theIS.texmap_reflectionIor theIS.texmap_reflectionIor_multiplier) 
						theOs.trans_ior_map_on = theIS.texmap_reflectionIor_on
					)
				)
			)
			
			----find a way to map anisotropy!
			--Transparency
			if theIS.Refraction!=black or ( theIS.texmap_refraction!=undefined and theIS.texmap_refraction_on!=false ) do
			(
				theOS.transparency=theIS.Refraction.v / 255.
				theOS.trans_color=theIS.Refraction
				theOS.trans_color_map =  (implicitateMapInfluence theIS.texmap_refraction theIS.texmap_refraction_multiplier)  
				theOS.trans_color_map_on = theIS.texmap_refraction_on
				theOS.trans_roughness_lock=false
				theOS.trans_roughness_inv=true
				theOS.trans_roughness = theIS.refraction_glossiness
				theOS.trans_rough_map = (implicitateMapInfluence theIS.texmap_refractionGlossiness theIS.texmap_refractionGlossiness_multiplier) 
				theOS.trans_rough_map_on = theIS.texmap_refractionGlossiness_on
			)
			----no dispersion
			--Emission
			if theIS.selfIllumination!=black or ( theIS.texmap_selfIllumination!=undefined and theIS.texmap_selfIllumination_on!=false ) do
			(			
				theOS.emission=1
				theOS.emit_color = theIS.selfIllumination
				theOS.emit_color_map = (implicitateMapInfluence theIS.texmap_selfIllumination theIS.texmap_selfIllumination) 
				theOS.emit_color_map_on = theIS.texmap_selfIllumination_on
				theOS.emit_luminance = theIS.selfIllumination_multiplier * 477.4646464646464646
			)
			--Scattering
			----None for the standard material for now.Convert vray sss2 in case
			theOS.scattering=0.0
			--Coating
			----None for the standard material
			theOS.coating = 0.0
			--Bump
			theOS.bump_map_amt=theIS.texmap_bump_multiplier/100.
			theOS.bump_map = theIS.texmap_bump
			theOS.bump_map_on = theIS.texmap_bump_on
			--Displacement
			theOS.displacement_map_amt=theIS.texmap_displacement_multiplier/100.
			theOS.displacement_map = theIS.texmap_displacement
			theOS.displacement_map_on = theIS.texmap_displacement_on			
			--Opacity
			theOS.cutout_map = theIS.texmap_opacity
			theOS.cutout_map_on = theIS.texmap_opacity_on
			
		)
		
		theOS
	)
	
	fn convertShaders doSelectedOnly theGamma = 
	(
		st=timestamp()
		theShaders=#()		
		if doSelectedOnly then
		(
			for sel in (selection as array) do
			(
				append theShaders (getclassinstances vrayMtl target:sel)
			)
			if theShaders.count >=2 do
			(
				
				for s in theShaders do
				(
					replaceInstances s[1] (convertShader s[1] (physicalMaterial()) theGamma) transferCAs:true
					convertedCount+=1
				)
			)
		)
		else
		(
			theShaders=getclassinstances vrayMtl
			if theShaders.count != 0 do
			(
			for s in theShaders do
				(
					replaceInstances s (convertShader s (physicalMaterial()) theGamma) transferCAs:true
					convertedCount+=1
				)
			)
		)
		theTime=(timestamp()-st)/1000.
		print ("Converted " + convertedCount as string + " shaders in " + theTime as string + "secs")
	)
	
	
	
	rollout physmatConverterRoll "V-Ray To PhysMat Converter" width:216 height:48
	(
		button 'selBtn' "Convert Selected" pos:[8,8] width:96 height:32 align:#left
		button 'allBtn' "Convert All" pos:[112,8] width:96 height:32 align:#left
		
		on selBtn pressed do
		(
			undo "Conversion of Selected to PhysMats" on
			(
				convertShaders true 2.2
			)
		)
		on allBtn pressed do
		(
			undo "Conversion of All to PhysMats" on
			(
				convertShaders false 2.2
			)
		)
	)
	
	createDialog physmatConverterRoll
)